unit NNNodeStructure;

interface

uses
    math,sysutils,Dialogs;

type
    TNNNode = Class(TObject)
    private
        FData:Pointer;
        FSize:Integer;
        Next:TNNNode;
        Prev:TNNNode;
    public

        property Data:Pointer read FData;
        property Size:Integer read FSize;
        constructor Create(_data:Pointer;_size:Integer);
        //_data_sizeRs[ĎŎ
        destructor Destroy;override;
        //̃
    end;

    TNNQueue = Class(TObject)
    private
        FHead:TNNNode;
        FTail:TNNNode;
        FCount:Integer;
        PickedNode:TNNNode;//Pickŉ
    public
        property Count:Integer read FCount;
        destructor Destroy;override;
        procedure Put(_data:Pointer;_size:Integer);
        function Pick:Pointer;
    end;

    {
        Format
        i : Integer
        t : Text -> StringǁAꎩ͕̂ςȃq[vV[vrȂ̂ŕʖ
        s : Single
        w : Word
        c : Char
        b : Bin ->  ArgsɁAJnAhXATCY@ƁA̃|C^Ŏw肷
                    unpackł́ATCYPIntegernilŁATCY󂯎ȂĂǂ


    }

    //ɎāAɏ
    //KvɂȂTCYԂĂяoŉĂ炤
    function Pack(var PackData:Pointer;Format:String;Args:Array of Pointer):Integer;
    //nꂽAhXWJ
    //gpATCY݂͂Ȃ
    procedure UnPack(PackData:Pointer;Format:String;Args:Array of Pointer);


implementation

function Pack(var PackData:Pointer;Format:String;Args:Array of Pointer):Integer;
var count:integer;//쒆Args
    spos:integer; //Formatǂ񂾕
    ret:Integer;
    temp:integer;
    procedure SimpleCopy(size:integer);
    begin
        ReallocMem(PackData,ret+size);
        Move(Args[count]^,Pointer(Integer(PackData)+ret)^,size);
        ret:=ret+size;
    end;
begin
    PackData:=nil;
    count:=0;
    spos:=1;
    ret:=0;
    while count<Length(Args) do begin
        Case Format[spos] of
            //4byte
            'i','s':begin
                SimpleCopy(4);
                Inc(count);
                Inc(spos);
            end;
            //2byte
            'w':begin
                SimpleCopy(2);
                Inc(count);
                Inc(spos);
            end;
            //1byte
            'c':begin
                SimpleCopy(1);
                Inc(count);
                Inc(spos);
            end;
            //t:    string@TCYAf[^@ŋLq
            't':begin
                //
                temp:=Length(String(PString(Args[count])^));
                ReallocMem(PackData,ret+4);
                Move(temp,Pointer(Integer(PackData)+ret)^,4);
                ret:=ret+4;
                //
                ReallocMem(PackData,ret+temp);
                Move(String(PString(Args[count])^)[1],Pointer(Integer(PackData)+ret)^,temp);
                ret:=ret+temp;
                Inc(count);
                Inc(spos);
            end;
            //b:    RoCi  ArgsɁAJn|C^ATCY|C^@ŗ
            //      łA@TCYAf[^@Ł@܂Ă
            'b':begin
                //oCi
                temp:=PInteger(Args[count+1])^;     //oCiǂ

                ReallocMem(PackData,ret+4);         //oCi
                Move(temp,Pointer(Integer(PackData)+ret)^,4);
                ret:=ret+4;
                //oCi
                ReallocMem(PackData,ret+temp);      //oCïm
                Move(Pointer(Args[count]^)^,Pointer(Integer(PackData)+ret)^,temp);
                ret:=ret+temp;

                Inc(count,2);                       //i
                Inc(spos);
            end;
        end;
    end;
    Result:=Ret;
end;

procedure UnPack(PackData:Pointer;Format:String;Args:Array of Pointer);
var count:integer;//쒆Args
    spos:integer; //Formatǂ񂾕
    ret:Integer;
    temp:integer;
    procedure SimpleCopy(size:integer);
    begin
        Move(Pointer(Integer(PackData)+ret)^,Args[count]^,size);
        ret:=ret+size;
    end;
begin
    count:=0;
    spos:=1;
    ret:=0;
    while count<Length(Args) do begin
        Case Format[spos] of
            //4byte
            'i','s':begin
                SimpleCopy(4);
                Inc(count);
                Inc(spos);
            end;
            //2byte
            'w':begin
                SimpleCopy(2);
                Inc(count);
                Inc(spos);
            end;
            //1byte
            'c':begin
                SimpleCopy(1);
                Inc(count);
                Inc(spos);
            end;
            //t:    string@TCYAf[^@ŋLq
            't':begin
                //
                Move(Pointer(Integer(PackData)+ret)^,temp,4);
                ret:=ret+4;
                //
                SetLength(String(PString(Args[count])^),temp);
                Move(Pointer(Integer(PackData)+ret)^,String(PString(Args[count])^)[1],temp);
                ret:=ret+temp;
                Inc(count);
                Inc(spos);
            end;
            //b:    RoCi  ArgsɁAJn|C^ATCY|C^@ŗ
            //      łA@TCYAf[^@Ł@܂Ă
            'b':begin
                //oCi
                Move(Pointer(Integer(PackData)+ret)^,temp,4);   //TCYǂݍ
                if Args[count+1]<>nil then begin
                    PInteger(Args[count+1])^:=temp;                 //TCYn
                end;
                ret:=ret+4;                                     //i

                //oCi
                Pointer(Args[count]^):=nil;
                ReallocMem(Pointer(Args[count]^),temp);

                Move(Pointer(Integer(PackData)+ret)^,Pointer(Args[count]^)^,temp);
                ret:=ret+temp;                                  //Rs[

                Inc(count,2);
                Inc(spos);
            end;
        end;
    end;
end;

constructor TNNNode.Create(_data:Pointer;_size:Integer);
begin
    inherited Create;
    if _size>0 then begin
        GetMem(FData,_size);            //m
        Move(_data^,FData^,_size);      //̂̂ɃRs[
        FSize:=_size;
    end else begin
        FData:=nil;                     //TCY0ȂRs[Ȃ
        FSize:=0;
    end;
end;

destructor TNNNode.Destroy;
begin
    if FSize>0 then begin
        //
        FreeMem(FData,FSize);
    end;
    inherited Destroy;
end;

destructor TNNQueue.Destroy;
begin
    if PickedNode<>nil then begin
        PickedNode.Free;
        PickedNode:=nil;
    end;
end;

procedure TNNQueue.Put(_data:Pointer;_size:Integer);
var node:TNNNode;
begin
    node:=TNNNode.Create(_data,_size);
    if FHead=nil then begin
        FHead:=node;
        node.Prev:=nil;
    end;
    node.Next:=nil;
    if FTail<>nil then begin
        FTail.Next:=node;
        node.Prev:=FTail;
    end;
    FTail:=node;
    FCount:=FCount+1;
end;

function TNNQueue.Pick:Pointer;
var n:TNNNode;
begin
    if FHead=nil then begin
        Result:=Nil;
        Exit;
    end;

    if PickedNode<>nil then begin
        PickedNode.Free;
        PickedNode:=nil;
    end;
    PickedNode:=FHead;

    n:=FHead.Next;
    FHead:=n;
    if n<>nil then begin
        n.Prev:=nil;
    end else begin
        FTail:=nil;
    end;

    Result:=PickedNode.Data;

    FCount:=FCount-1;

end;

end.
